Index: branches/2.5/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- branches/2.5/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 8114)
+++ branches/2.5/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 8232)
@@ -42,5 +42,5 @@
 	var $useCache = false;
 	var $expirationCache = false;
-
+    var $msgIds = array();// Usado para guardar o messagesIds
         
 	function imap_functions (){
@@ -233,69 +233,74 @@
                                     ++$i;
                             }
-							
-							$filter = array('AND', array('=', 'folderName', $folder), array('IN','messageNumber', $sort_array_msg));
-							$followupflagged = Controller::find(
-								array('concept' => 'followupflagged'),
-								false, 
-								array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-							);
-							$labeleds = Controller::find(
-								array('concept' => 'labeled'),
-								false, 
-								array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-							);
-                            $sort_array_msg_count = count($sort_array_msg);
-							for($i=0; $i<$sort_array_msg_count; ++$i){
-								if(!isset($return[$i]['msg_number']))
-									continue;
-									
-								$numFlags = count($followupflagged);
-								for($ii=0; $ii<$numFlags; ++$ii){
-									if($return[$i]['msg_number'] == $followupflagged[$ii]['messageNumber']){
-										$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[$ii]['followupflagId'] ));
-										$return[$i]['followupflagged'] = $followupflagged[$ii];
-										$return[$i]['followupflagged']['followupflag'] = $followupflag;
-										break;
-									}
-								}
-								$numLabels = count($labeleds);
-								for($ii=0; $ii<$numLabels; ++$ii){
-									if($return[$i]['msg_number'] == $labeleds[$ii]['messageNumber']){
-										$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $labeleds[$ii]['labelId'])); 
-										$return[$i]['labels'][$labeleds[$ii]['labelId']] = $labels;
-									}
-								}
-							}
+                            if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_followupflags_and_labels'] == "1")
+                            {
+                                $filter = array('AND', array('=', 'folderName', $folder), array('IN','messageNumber', $sort_array_msg));
+                                $followupflagged = Controller::find(
+                                    array('concept' => 'followupflagged'),
+                                    false,
+                                    array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+                                );
+                                $labeleds = Controller::find(
+                                    array('concept' => 'labeled'),
+                                    false,
+                                    array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+                                );
+                                $sort_array_msg_count = count($sort_array_msg);
+                                for($i=0; $i<$sort_array_msg_count; ++$i){
+                                    if(!isset($return[$i]['msg_number']))
+                                        continue;
+
+                                    $numFlags = count($followupflagged);
+                                    for($ii=0; $ii<$numFlags; ++$ii){
+                                        if($return[$i]['msg_number'] == $followupflagged[$ii]['messageNumber']){
+                                            $followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[$ii]['followupflagId'] ));
+                                            $return[$i]['followupflagged'] = $followupflagged[$ii];
+                                            $return[$i]['followupflagged']['followupflag'] = $followupflag;
+                                            break;
+                                        }
+                                    }
+                                    $numLabels = count($labeleds);
+                                    for($ii=0; $ii<$numLabels; ++$ii){
+                                        if($return[$i]['msg_number'] == $labeleds[$ii]['messageNumber']){
+                                            $labels = Controller::read( array( 'concept' => 'label', 'id' =>  $labeleds[$ii]['labelId']));
+                                            $return[$i]['labels'][$labeleds[$ii]['labelId']] = $labels;
+                                        }
+                                    }
+                                }
+                            }
                     }
                     $return['num_msgs'] =  $num_msgs;   
-		} else {
+		}
+        else
+        {
 			$num_msgs = imap_num_msg($this->mbox);
 			$sort_array_msg = $this-> get_msgs($folder, $sort_box_type, $search_box_type, $sort_box_reverse,$msg_range_begin,$num_msgs);
 
-
 			$return['tot_unseen'] = 0;
 			$i = 0;
 
-                        if(is_array($sort_array_msg)){
-
-                            foreach($sort_array_msg as $msg_number => $value)
-                            {
-                                $temp = $this->get_info_head_msg($msg_number);
-                                if(!$temp)
-                                    return false;
-
-                                if($temp['Unseen'] == 'U' || $temp['Recent'] == 'N'){
-						$return['tot_unseen']++;
-					}
-
-                                if($i <= ($msg_range_end-$msg_range_begin))
-                                    $return[$i] = $temp;
-                                ++$i;
-                            }
-                        }
-      			$return['num_msgs'] = count($sort_array_msg)+($msg_range_begin-1);
+            if(is_array($sort_array_msg))
+            {
+                foreach($sort_array_msg as $msg_number => $value)
+                {
+                    $temp = $this->get_info_head_msg($msg_number);
+                    if(!$temp)
+                        return false;
+
+                    if($temp['Unseen'] == 'U' || $temp['Recent'] == 'N')
+                        $return['tot_unseen']++;
+
+                    if($i <= ($msg_range_end-$msg_range_begin))
+                        $return[$i] = $temp;
+
+                    ++$i;
                 }
-				          	
-                return $return; 
+            }
+
+            $return['num_msgs'] = count($sort_array_msg)+($msg_range_begin-1);
+        }
+
+        $return['messagesIds'] = $this->msgIds;
+        return $return;
     }
 	
@@ -458,7 +463,13 @@
             $return['attachment'] = ( preg_match('/((Content-Disposition:(.)*([\r\n\s]*filename))|(Content-Type:(.)*([\r\n\s]*name)))/i', $mimeBody) ) ? '1' : '0'; //Verifica se a anexos na mensagem
             $return['reply_toaddress'] = isset($header->reply_toaddress) ? self::decodeMimeString($header->reply_toaddress) : '';
-            $return['flag'] = $header->Unseen.$header->Recent.$header->Flagged.$header->Draft.$header->Answered.$header->Deleted.( $return['attachment'] === '1' ? 'T': '' );
-			
-			if (!empty($header->to)){
+            $return['flag'] = $header->Unseen.
+                $header->Recent.
+                ($header->Flagged == 'F' || !( preg_match('/importance *: *(.*)\r/i', $mimeHeader , $importance) === 0 )? 'F' : '').
+                $header->Draft.
+                $header->Answered.
+                $header->Deleted.
+                ( $return['attachment'] === '1' ? 'T': '' );
+
+        if (!empty($header->to)){
 				foreach ($header->to as $i => $v){
 					$return['to'][$i] = self::formatMailObject( $v );
@@ -592,10 +603,10 @@
 					if (zip_entry_open($zip, $zip_entry, "r")) {
 						$email = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
- 
-                                                /*Caso mensagens vierem com quebras de linha diferentes do esperado, como por exemplo, 
-                                                mensagens exportadas pelo MailArchiver, é preciso corrigir.*/ 
-                                                $email = str_replace("\r\n", "\n", $email); 
-                                                $email = str_replace("\n", "\r\n", $email); 
- 
+
+						/*Caso mensagens vierem com quebras de linha diferentes do esperado, como por exemplo,
+						mensagens exportadas pelo MailArchiver, é preciso corrigir.*/
+						$email = str_replace("\r\n", "\n", $email);
+						$email = str_replace("\n", "\r\n", $email);
+
 						$status = @imap_append($this->mbox,
 								"{".$this->imap_server.":".$this->imap_port.$this->imap_options."}".$params["folder"],
@@ -620,10 +631,10 @@
 		}else if(substr($filename,strlen($filename)-4)==".eml") {
 			$email = implode("",file($params['FILES'][0]['tmp_name']));
- 
-                        /*Caso mensagens vierem com quebras de linha diferentes do esperado, como por exemplo, 
-                        mensagens exportadas pelo MailArchiver, é preciso corrigir.*/ 
-                        $email = str_replace("\r\n", "\n", $email); 
-                        $email = str_replace("\n", "\r\n", $email); 
- 
+
+			/*Caso mensagens vierem com quebras de linha diferentes do esperado, como por exemplo,
+			mensagens exportadas pelo MailArchiver, é preciso corrigir.*/
+			$email = str_replace("\r\n", "\n", $email);
+			$email = str_replace("\n", "\r\n", $email);
+
 			$status = imap_append($this->mbox,"{".$this->imap_server.":".$this->imap_port.$this->imap_options."}".$params["folder"],$email);
 				
@@ -954,4 +965,5 @@
 
                                    $content .= $this->decodeMailPart($part->body,$part->ctype_parameters['charset']);
+                                   $i = -1;
                                 }
 
@@ -962,26 +974,26 @@
 
                                    $content .= '<pre>'. htmlentities($this->decodeMailPart($part->body,$part->ctype_parameters['charset'],false)).'</pre>';
+                                   $i = -1;
                                 }
-                                if(strtolower($part->ctype_secondary) == 'calendar')
-                                    $content.= $this->builderMsgCalendar($this->decodeMailPart($part->body, $part->ctype_parameters['charset']));
-
+                               // Comentado para tratamento de e-mail multipart alternative com html e ical. Parseava o ical e ignorava o html.
+                               //if(strtolower($part->ctype_secondary) == 'calendar')
+                               //     $content.= $this->builderMsgCalendar($this->decodeMailPart($part->body, $part->ctype_parameters['charset']));
                            }
 
-                            $i = -1;
                             break;
 
                        case 'multipart':
 
- 	                    if(strtolower($part->ctype_secondary) == 'alternative' ) //Unico formato multipart suportado, escapa os outros 
- 	                    { 
- 	                        if($printHeader) 
- 	                            $content .= $this->builderMsgHeader($part); 
-
- 	                        $this->builderMsgBody($part,$content); 
-
- 	                        $i = -1; 
- 	                    } 
- 
- 	                    break;
+                           if(strtolower($part->ctype_secondary) == 'alternative' ) //Unico formato multipart suportado, escapa os outros
+                           {
+                               if($printHeader)
+                                   $content .= $this->builderMsgHeader($part);
+
+                               $this->builderMsgBody($part,$content);
+
+                               $i = -1;
+                           }
+
+                           break;
 
                        case 'message':
@@ -1211,6 +1223,6 @@
 
 		$return['msg_number'] = $msg_number.$plus_id;
-                $return['msg_folder'] = mb_convert_encoding( $msg_folder, "ISO-8859-1", "UTF-8" ); 
-                //isset($params['decoded']) ? mb_convert_encoding( $msg_folder, "ISO-8859-1", "UTF-8" ) : $msg_folder; 
+		$return['msg_folder'] = mb_convert_encoding( $msg_folder, "ISO-8859-1", "UTF-8" );
+		//isset($params['decoded']) ? mb_convert_encoding( $msg_folder, "ISO-8859-1", "UTF-8" ) : $msg_folder;
 
 		
@@ -1460,5 +1472,5 @@
 		}  
 		$return['alarm'] = $alarm;
-		
+
 		return $return;
 	}
@@ -2186,8 +2198,8 @@
 	function delete_msgs($params)
 	{
-
 		$folder = $params['folder'];
 		$folder =  mb_convert_encoding($folder, "UTF7-IMAP","ISO-8859-1");
 		$msgs_number = explode(",",$params['msgs_number']);
+
 		if(array_key_exists('border_ID' ,$params))
 		$border_ID = $params['border_ID'];
@@ -2205,5 +2217,5 @@
 	 	$mbox_stream = @imap_open("{".$this->imap_server.":".$this->imap_port.$this->imap_options."}".$folder, $this->username, $this->password) or die(serialize(array('imap_error' => $this->parse_error(imap_last_error()))));
 
-		foreach ($msgs_number as $msg_number)
+        foreach ($msgs_number as $msg_number)
 		{
 			if (imap_delete($mbox_stream, $msg_number, FT_UID));
@@ -2650,10 +2662,10 @@
 	function ren_mailbox($arr)
 	{
-                $namebox = $arr['current'];              
-                $path_delimiter = strrpos($namebox,$this->imap_delimiter)+1; 
-                $base_path = substr($namebox,0,$path_delimiter); 
-                $rename = preg_split("/\/|\./",substr($arr['rename'], $path_delimiter)); 
-                $new_box = array_shift($rename); 
-                $subfolders = $rename; 
+		$namebox = $arr['current'];		
+		$path_delimiter = strrpos($namebox,$this->imap_delimiter)+1;
+		$base_path = substr($namebox,0,$path_delimiter);
+		$rename = preg_split("/\/|\./",substr($arr['rename'], $path_delimiter));
+		$new_box = array_shift($rename);
+		$subfolders = $rename;
 		$imap_server = $_SESSION['phpgw_info']['expressomail']['email_server']['imapServer'];
 		$mbox_stream = $this->open_mbox();
@@ -2666,20 +2678,20 @@
 			$result = imap_last_error();
 		}
-                /*Cria as subpastas*/ 
-                if (is_array($subfolders)){ 
-                        $child = $new_box.$this->imap_delimiter; 
-            $subfolders_count = count($subfolders); 
-                        for($i =0; $i < $subfolders_count; ++$i){ 
-                                $child .= ($subfolders[$i] ? $subfolders[$i] : $this->functions->getLang("New Folder")); 
-                                $namebox =  mb_convert_encoding($child, "UTF7-IMAP", "UTF-8"); 
-                                $result = "Ok"; 
-                                if(!imap_createmailbox($mbox_stream,"{".$imap_server."}$namebox")) 
-                                { 
-                                        $result = imap_last_error();                                             
-                                } 
-                                $child .=$this->imap_delimiter; 
-                        }                        
-                } 
- 
+		/*Cria as subpastas*/
+		if (is_array($subfolders)){
+			$child = $new_box.$this->imap_delimiter;
+            $subfolders_count = count($subfolders);
+			for($i =0; $i < $subfolders_count; ++$i){
+				$child .= ($subfolders[$i] ? $subfolders[$i] : $this->functions->getLang("New Folder"));
+				$namebox =  mb_convert_encoding($child, "UTF7-IMAP", "UTF-8");
+				$result = "Ok";
+				if(!imap_createmailbox($mbox_stream,"{".$imap_server."}$namebox"))
+				{
+					$result = imap_last_error();						
+				}
+				$child .=$this->imap_delimiter;
+			}			
+		}
+
 		if($mbox_stream)
 			imap_close($mbox_stream);
@@ -2711,5 +2723,23 @@
 		return $return;
 	}
-	
+
+	/*Método utilizado para retornar dados da mensagem local (desarquivada na pasta lixeira)
+	para poder ser anexada à mensagem.*/
+    function get_info_msg_archiver($params){
+        $folder = "INBOX".$this->imap_delimiter.$this->folders['trash'];
+        $mbox_stream = $this->open_mbox($folder);
+        $id = $params['idMsgs'];
+
+        $name = imap_headerinfo($mbox_stream, imap_msgno($mbox_stream, $id));
+        $return[] =  array(
+            'uid' => $id,
+            'folder' => "archiver",
+            'type' => "imapMSG",
+            'name' => base64_encode($name->subject.".eml")
+        );
+
+        return json_encode($return);
+    }
+
 	function send_mail($params) {
             require_once dirname(__FILE__) . '/../../services/class.servicelocator.php';
@@ -2934,5 +2964,5 @@
 					$arr_new_folder['base_path'] = $base_path;
 
-					$this->create_mailbox($arr_new_folder);					
+					$this->create_mailbox($arr_new_folder);	
 					$has_new_folder = true;
                     $folder = $newfolder;
@@ -2954,5 +2984,5 @@
 
 			$from = $fromaddress ?  ('"' . $fromaddress[0] . '" <' . $fromaddress[1] . '>') : ('"' . $_SESSION['phpgw_info']['expressomail']['user']['firstname'] . ' ' . $_SESSION['phpgw_info']['expressomail']['user']['lastname'] . '" <' . $_SESSION['phpgw_info']['expressomail']['user']['email'] . '>');
-			$mailService->setFrom($from);				
+			$mailService->setFrom( mb_convert_encoding($from, "ISO-8859-1","UTF-8, ISO-8859-1"));
         
 			$mailService->addHeaderField('Reply-To', !!$replytoaddress ? $replytoaddress : $from);
@@ -3004,6 +3034,5 @@
             $isHTML = ( isset($params['type']) && $params['type'] == 'html' )?  true : false;
 
-
-    //	TODO - tratar mensagem criptografada e remover o AND false abaixo
+    		//	TODO - tratar mensagem criptografada e remover o AND false abaixo
             if (($encrypt && $signed && $params['smime']) || ($encrypt && !$signed) AND false) { // a msg deve ser enviada cifrada...
                 $email = $this->add_recipients_cert($toaddress . ',' . $ccaddress . ',' . $ccoaddress);
@@ -3103,4 +3132,7 @@
                 {
                     $value = json_decode($value, true);
+                    if($value["folder"] == "archiver"){
+                        $value['folder'] = "INBOX/Trash";
+                    }
 
                     switch ($value['type']) {
@@ -3110,5 +3142,5 @@
                                 if(strstr($body,'src="./inc/get_archive.php?msgFolder='.$value['folder'].'&msgNumber='.$value['uid'].'&indexPart='.$value['part'].'"') !== false)//Embeded IMG
                                 {    
-                                    $body = str_ireplace('src="./inc/get_archive.php?msgFolder='.$value['folder'].'&msgNumber='.$value['uid'].'&indexPart='.$value['part'].'"' , 'src="'.$att['name'].'"', $body);
+                                    $body = str_ireplace('src="./inc/get_archive.php?msgFolder='.$value['folder'].  '&msgNumber='.$value['uid'].'&indexPart='.$value['part'].'"' , 'src="'.$att['name'].'"', $body);
                                     $mailService->addStringImage($att['source'], $att['type'],mb_convert_encoding($att['name'], 'ISO-8859-1' , 'UTF-8,ISO-8859-1') );
                                 }
@@ -3124,4 +3156,5 @@
                                 
                                 $mailService->addStringAttachment($rawmsg, mb_convert_encoding(base64_decode($value['name']), 'ISO-8859-1' , 'UTF-8,ISO-8859-1'), 'message/rfc822', '7bit', 'attachment' );
+                                /*envia o anexo para o email*/
                                 $message_size_total += mb_strlen($rawmsg); //Adiciona o tamanho do anexo a variavel que controlao tamanho da msg.
                                 unset($rawmsg);
@@ -3419,4 +3452,7 @@
 			$sort = array();
 		}
+
+        $this->msgIds = $sort;
+
 		if ($slice_array)
 			$sort = array_slice($sort,$offsetBegin-1,$offsetEnd-($offsetBegin-1),true);
@@ -3556,4 +3592,18 @@
 	}
 
+    function verifyShareFolder($params){
+        $folder = $params['folder'];
+
+         if (substr($folder,0,4) == 'user'){
+            $acl = $this->getacltouser($folder, isset($params['decoded']));
+
+            $acl_share_delete = (stripos($acl,'t') !== false && stripos($acl,'e') !== false);
+
+            if (!$acl_share_delete) {
+                $return['status'] = false;
+                return $return;
+            }
+        }
+    }
 	function move_messages($params)
 	{
@@ -3676,5 +3726,5 @@
 	}
 	
-	function set_messages_flag_from_search($params){		
+	function set_messages_flag_from_search($params){
 		$error = False;
 		$fileNames = "";
@@ -4404,29 +4454,31 @@
                                             $elem['uid'] = $new_search;
                                             /* compare dates in ordering */
-                                            $elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);  
-
-											$filter = array('AND', array('=', 'folderName', $name_box), array('=','messageNumber', $new_search));
-											$followupflagged = Controller::find(
-												array('concept' => 'followupflagged'),
-												false, 
-												array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-											);
-
-											if(isset($followupflagged[0]['followupflagId']))
-											{
-												$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));     
-												$followupflagged[0]['followupflag'] = $followupflag;
-												$elem['followupflagged'] = $followupflagged[0];
-
-											}	
-											$labeleds = Controller::find(
-												array('concept' => 'labeled'),
-												false, 
-												array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-											);
-											foreach ($labeleds as $e){
-												$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));     
-												$elem['labels'][$e['labelId']] = $labels;
-}											
+                                            $elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);
+                                            if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_followupflags_and_labels'] == "1")
+                                            {
+                                                $filter = array('AND', array('=', 'folderName', $name_box), array('=','messageNumber', $new_search));
+                                                $followupflagged = Controller::find(
+                                                    array('concept' => 'followupflagged'),
+                                                    false,
+                                                    array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+                                                );
+
+                                                if(isset($followupflagged[0]['followupflagId']))
+                                                {
+                                                    $followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));
+                                                    $followupflagged[0]['followupflag'] = $followupflag;
+                                                    $elem['followupflagged'] = $followupflagged[0];
+
+                                                }
+                                                $labeleds = Controller::find(
+                                                    array('concept' => 'labeled'),
+                                                    false,
+                                                    array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+                                                );
+                                                foreach ($labeleds as $e){
+                                                    $labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));
+                                                    $elem['labels'][$e['labelId']] = $labels;
+                                                }
+                                            }
                                             $retorno[] = $elem;
                                         }
@@ -4460,5 +4512,5 @@
 	    $arrayRetorno['data']		=  $pageret;
 	    $arrayRetorno['currentTab'] =  $params['current_tab'];
-            return ($pageret) ? $arrayRetorno : 'none';
+        return ($pageret) ? $arrayRetorno : 'none';
 	}
 
@@ -4546,9 +4598,9 @@
 	            {
 	                $folder = str_replace($serverString, "", imap_utf7_decode($val->name));
-                        //$folder = str_replace("&-", "&", $folder);                     
-                        $trashFolder = explode($this->imap_delimiter,$folder); 
-                        $acls = ($trashFolder[count($trashFolder) - 1] == "Trash") ? $value['acls']."i" : $value['acls']; 
-                        $folder = imap_utf7_encode($folder);                     
-                        imap_setacl ($mbox_stream, $folder, "$user", $acls); 
+	                //$folder = str_replace("&-", "&", $folder);			
+	                $trashFolder = explode($this->imap_delimiter,$folder);
+	                $acls = ($trashFolder[count($trashFolder) - 1] == "Trash") ? $value['acls']."i" : $value['acls'];
+	                $folder = imap_utf7_encode($folder);	                
+	                imap_setacl ($mbox_stream, $folder, "$user", $acls);
 	            }
 	        }
@@ -4909,4 +4961,5 @@
 				$insert = $this->insert_email($source,$dest_folder,$timestamps[$index],$flags[$index]);
 
+                $return['idsMsg'] = $insert['msg_no'];
                 if($insert['error'])
                 {
@@ -5070,33 +5123,39 @@
 				foreach ($subject as $tmp)
 					$return['msgs'][$i]['subject'] .= mb_convert_encoding($tmp->text, 'UTF-8', 'UTF-8 , ISO-8859-1');
-				
-				$filter = array('AND', array('=', 'folderName', $folder), array('=','messageNumber', $v));
-				$followupflagged = Controller::find(
-					array('concept' => 'followupflagged' , 'folder' => $folder ),
-					false, 
-					array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-				);
-
-				if(isset($followupflagged[0]['followupflagId']))
-				{
-					$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));     
-					$followupflagged[0]['followupflag'] = $followupflag;
-					$return['msgs'][$i]['followupflagged'] = $followupflagged[0];
-
-				}	
-				$labeleds = Controller::find(
-					array('concept' => 'labeled'),
-					false, 
-					array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-				);
-				if(is_array($labeleds))
-				foreach ($labeleds as $e){
-					$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));     
-					$return['msgs'][$i]['labels'][$e['labelId']] = $labels;
-				}	
+
+
+                if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_followupflags_and_labels'] == "1")
+                {
+
+                    $filter = array('AND', array('=', 'folderName', $folder), array('=','messageNumber', $v));
+                    $followupflagged = Controller::find(
+                        array('concept' => 'followupflagged' , 'folder' => $folder ),
+                        false,
+                        array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+                    );
+
+                    if(isset($followupflagged[0]['followupflagId']))
+                    {
+                        $followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));
+                        $followupflagged[0]['followupflag'] = $followupflag;
+                        $return['msgs'][$i]['followupflagged'] = $followupflagged[0];
+
+                    }
+                    $labeleds = Controller::find(
+                        array('concept' => 'labeled'),
+                        false,
+                        array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+                    );
+                    if(is_array($labeleds))
+                    foreach ($labeleds as $e){
+                        $labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));
+                        $return['msgs'][$i]['labels'][$e['labelId']] = $labels;
+                    }
+                }
+
 				$mimeBody = imap_body( $this->mbox, $v  , FT_UID|FT_PEEK  );
 				$return['msgs'][$i]['flag'] = ' ';
 				$return['msgs'][$i]['flag'] .= $msg->Unseen ? $msg->Unseen : '';
-				$return['msgs'][$i]['flag'] .= $msg->Recent ? $msg->Recent : '';	
+				$return['msgs'][$i]['flag'] .= $msg->Recent ? $msg->Recent : '';
 				$return['msgs'][$i]['flag'] .= $msg->Draft ? $msg->Draft : '';	
 				$return['msgs'][$i]['flag'] .= $msg->Answered ? $msg->Answered : '';	
@@ -5159,9 +5218,9 @@
 			$nMsgs[] = $v;
 		}
-		$return['msgs'] = $nMsgs;	
-		
-		$return = json_encode($return);		
+		$return['msgs'] = $nMsgs;
+
+		$return = json_encode($return);
 		$return = base64_encode($return);
-	
+        
 		return $return;
 	}
@@ -5227,16 +5286,17 @@
 	function searchSieveRule( $params )
 	{
- 
-		$imap = $this->open_mbox( 'INBOX' );
+		$imap = $this->open_mbox( $params['folder']['criteria'] ? $params['folder']['criteria'] : 'INBOX' );
 		$msgs = imap_sort( $imap , SORTDATE , 0 , SE_UID);
-		
+	
 		$rr = array();
- 
+
         if(isset($params['from']))  $rr['from'] = array();
         if(isset($params['to']))  $rr['to'] = array();
         if(isset($params['subject'])) $rr['subject'] = array();
-        if(isset($params['body'])) $rr['body'] = array(); 
-        if(isset($params['size'])) $rr['size'] = array(); 
- 
+        if(isset($params['body'])) $rr['body'] = array();
+        if(isset($params['size'])) $rr['size'] = array();
+
+        //$params['search'] = mb_convert_encoding($params['search'], 'UTF-8',mb_detect_encoding($params['search'].'x', 'UTF-8, ISO-8859-1'));
+
 		foreach ($msgs as $i => $v)
 		{
@@ -5264,5 +5324,5 @@
 			
 			if(isset($params['to']))
-			{ 
+			{
 				$tos = $msg->to;
 				$val = '';
@@ -5284,5 +5344,5 @@
 					
 				}
-				
+
 				if($this->filterCheck( $val , $params['to']['criteria'] , $params['to']['filter'] ))
 					$rr['to'][] = $v;
@@ -5294,5 +5354,5 @@
 				$subject = imap_mime_header_decode($msg->subject);
 				foreach ($subject as $tmp)
-					$ss .= $tmp->text;
+					$ss .= ($tmp->charset == "default") ? $tmp->text : utf8_encode($tmp->text);
 				
 				if($this->filterCheck($ss , $params['subject']['criteria'] , $params['subject']['filter'] ))
@@ -5302,10 +5362,10 @@
 			if(isset($params['body']))
 			{			
-				$this->mbox = $this->open_mbox( 'INBOX' );
-				$b = $this->get_body_msg( $v , 'INBOX' );
-				
-				if( $this->filterCheck( $b['body'] , $params['body']['criteria'] , $params['body']['filter'] ))
+				$this->mbox = $this->open_mbox( $params['folder']['criteria'] ? $params['folder']['criteria'] : 'INBOX' );
+				$b = $this->get_body_msg( $v , $params['folder']['criteria'] ? $params['folder']['criteria'] : 'INBOX' );
+
+				if( $this->filterCheck( mb_convert_encoding(html_entity_decode($b['body']), 'UTF-8',mb_detect_encoding(html_entity_decode($b['body']).'x', 'UTF-8, ISO-8859-1')) , $params['body']['criteria'] , $params['body']['filter'] ))
 					$rr['body'][] = $v;
-				
+
 				unset($b);
 			}
@@ -5320,17 +5380,13 @@
 		$rrr = array();
 		$init = true;
-		
-		
 		foreach ($rr as $i => $v)
-		{			
+		{
 			if(count($rrr) == 0 && $init === true)
 				$rrr = $v;
 			else if($params['isExact'] == 'yes')
-                		$rrr = array_intersect($rrr , $v);
+                $rrr = array_intersect($rrr , $v);
 			else
 				$rrr =  array_unique(array_merge($rrr , $v));
-			
-		}
-		
+		}
 
 //		if($params['page'] && $params['rows'])
